//Behold... baby's first LUA spaghetti dish! Fear its overcomplicated recipe!

//custom sound effects for her footsteps and easter egg
freeslot("sfx_msquid", "sfx_hfclp1", "sfx_hfclp2", "sfx_gllop1", "sfx_gllop2", 
		"sfx_rglhrs")
sfxinfo[sfx_msquid].caption = "Horse sneaking"
sfxinfo[sfx_hfclp1].caption = "Horse walking"
sfxinfo[sfx_hfclp2].caption = "Horse walking"
sfxinfo[sfx_gllop1].caption = "Horse running"
sfxinfo[sfx_gllop2].caption = "Horse running"
sfxinfo[sfx_rglhrs].caption = "the horse is here..."

//a local function to make skinchecking easier
local function EmSkinCheck(player)
	if player.mo == nil
		return false
	end
	if player.mo.skin != "emmette"
		return false
	end
	return true
end

/*this function just makes different jumps easier to manage since they all share
the same setup*/
local function JumpManager(mo, hight)
	/*this nerfs the jumps while underwater or in space so that the player 
	doesn't jump way higher underwater than on dry land*/
	if mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(mo)
		hight = $ - ($ / 3)
	end
	P_SetObjectMomZ(mo, hight)
end

local function StateSetter(mo, sstate)
	if mo.state != sstate
		mo.state = sstate
	end
end

//this function handles the horizontal speed for dives and slides
local function ThrustSpeeds(player)
	local thrustspeed = 0
	if player.speed > 30 * player.mo.scale
		thrustspeed = player.speed + 10 * player.mo.scale
	else
		thrustspeed = 40 * player.mo.scale
	end
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(player.mo)
		thrustspeed = $ - ($ / 3)
	end
	return thrustspeed
end

local function CrawlNPTrigger(player)
	if not EmSkinCheck(player)
		return
	end
	
	if player.mo.state == S_PLAY_PAIN or player.playerstate == PST_DEAD or 
			player.mo.state == S_PLAY_STUN
		return
	end
	if player.em_sliding == nil
		player.em_sliding = false
	end
	if player.em_pounding == nil
		player.em_pounding = false
	end
	//this makes the player crawl/slide if they hold spin while on the ground
	if P_IsObjectOnGround(player.mo)
		if player.mo.state != S_PLAY_ROLL
			player.pflags = $ | PF_JUMPSTASIS
			player.height = player.spinheight
			if player.normalspeed != 4 * FRACUNIT and (player.mo.momx != 
					0 or player.mo.momy != 0)
				if not player.em_sliding
					player.em_slidsped = ThrustSpeeds(player)
					player.em_sliding = true
				end
			else
				player.normalspeed = 4 * FRACUNIT
				if player.mo.momx == 0 and player.mo.momy == 0
					StateSetter(player.mo, S_PLAY_GLIDE)
				else
					StateSetter(player.mo, S_PLAY_CLIMB)
				end
			end
		end
	/*this triggers the boolean that runs the ground pound code if the player
	presses spin while in the air*/
	elseif not (player.cmd.buttons & BT_JUMP)
		if (player.pflags & PF_JUMPED or player.mo.state == S_PLAY_FALL or 
				player.mo.state == S_PLAY_ROLL) and player.powers[pw_carry] == 
				CR_NONE and player.mo.state != S_PLAY_CLING
			if not player.em_pounding
				//A_ForceStop(player.mo, 0)
				player.mo.momx = $ / 2
				player.mo.momy = $ / 2
				JumpManager(player.mo, 7 * FRACUNIT)
				player.em_hover = TICRATE
				player.pflags = $ & ~PF_THOKKED
				player.em_pounding = true
			end
		end
	end
	return true
end

//this makes the player spin, since a lot of abilities make them spin
local function Speening(player)
	if player.em_speen == nil
		player.em_speen = 0
	end
	player.em_speen = $ - 37
	player.drawangle = FixedAngle(player.em_speen * FRACUNIT)
end

local function SlideGPound(player)
	if player.powers[pw_carry] == CR_NIGHTSMODE
		player.mo.height = 46 * player.mo.scale
		return
	end
	//this resets the height and speed changes made by crawling/sliding
	if not (player.cmd.buttons & BT_SPIN and P_IsObjectOnGround(player.mo)) and
			not player.em_sliding
		player.height = skins[player.mo.skin].height
		player.normalspeed = skins[player.mo.skin].normalspeed
		if player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_CLIMB or
				player.mo.state == S_PLAY_DASH
			if player.pflags & PF_JUMPED
				player.mo.state = S_PLAY_JUMP
			else
				player.mo.state = S_PLAY_WALK
			end
		end
	end
	if player.mo.state == S_PLAY_PAIN or player.playerstate == PST_DEAD or 
			player.mo.state == S_PLAY_STUN
		player.em_pounding = false
		player.em_grounpwnd = false
		player.em_sliding = false
		return
	end
	//this makes the player roll if they hit a spring while crawling or sliding
	if player.mo.eflags & MFE_SPRUNG and P_IsObjectOnGround(player.mo) and 
			(player.mo.state == S_PLAY_GLIDE or player.em_sliding or 
			player.mo.state == S_PLAY_CLIMB)
		player.mo.state = S_PLAY_ROLL
		player.pflags = $ | PF_SPINNING
		player.em_sliding = false
		return
	end
	//this handles the sliding
	if player.em_sliding
		player.height = player.spinheight
		StateSetter(player.mo, S_PLAY_DASH)
		player.pflags = $ | PF_STASIS
		P_SpawnSkidDust(player, 10 * player.mo.scale, sfx_s3k7e)
		player.powers[pw_strong] = STR_PUNCH|STR_WALL|STR_ANIM
		if not P_IsObjectOnGround(player.mo) or (player.mo.momx == 0 and 
				player.mo.momy == 0) or player.em_slidsped <= 0
			if player.cmd.buttons & BT_SPIN and P_IsObjectOnGround(player.mo)
				player.normalspeed = 4 * FRACUNIT
			end
			player.em_sliding = false
		else
			P_InstaThrust(player.mo, player.mo.angle, player.em_slidsped)
			player.drawangle = player.mo.angle
			if player.em_prevz == nil
				player.em_prevz = player.mo.z
			end
			if player.mo.standingslope and (player.mo.z < player.em_prevz and 
					not (player.mo.eflags & MFE_VERTICALFLIP)) or (player.mo.z > 
					player.em_prevz and player.mo.eflags & MFE_VERTICALFLIP)
				player.em_slidsped = $ + player.mo.scale / 3
			elseif player.mo.standingslope and (player.mo.z > player.em_prevz and 
					not (player.mo.eflags & MFE_VERTICALFLIP)) or (player.mo.z < 
					player.em_prevz and player.mo.eflags & MFE_VERTICALFLIP)
				player.em_slidsped = $ - player.mo.scale
			else
				player.em_slidsped = $ - player.mo.scale / 3
			end
			player.em_prevz = player.mo.z
		end
	end
	//this is the ground pound code
	if player.em_grounpwnd == nil
		player.em_grounpwnd = false
	end
	if player.em_pounding
		//player.pflags = $ | PF_FULLSTASIS
		if player.em_hover > 0
			if player.mo.momz == 0
				player.mo.momz = 0
			end
			StateSetter(player.mo, S_PLAY_FLY)
			player.em_hover = $ - 8
		elseif not player.em_grounpwnd
			JumpManager(player.mo, -50 * FRACUNIT)
			player.em_grounpwnd = true
		else
			if player.mo.eflags & MFE_GOOWATER or player.powers[pw_carry] != 
					CR_NONE or (player.mo.momz > 0 and not (player.mo.eflags & 
					MFE_VERTICALFLIP)) or (player.mo.momz < 0 and 
					player.mo.eflags & MFE_VERTICALFLIP)
				if player.powers[pw_carry] != CR_NONE
					player.mo.state = S_PLAY_WALK
				elseif not (player.mo.state == S_PLAY_SPRING or player.mo.eflags
						& MFE_GOOWATER)
					JumpManager(player.mo, 7 * FRACUNIT)
					player.mo.state = S_PLAY_JUMP
				end
				player.em_grounpwnd = false
				player.em_pounding = false
			elseif not P_IsObjectOnGround(player.mo)
				Speening(player)
				if player.mo.state != S_PLAY_MELEE
					player.powers[pw_strong] = STR_FLOOR|STR_SPRING|STR_HEAVY|
							STR_STOMP|STR_ANIM
					player.mo.state = S_PLAY_MELEE
				end
			else
				S_StartSound(player.mo, sfx_pstop)
				local px = player.mo.x
				local py = player.mo.y
				local br = 75 * player.mo.scale
				local mo = player.mo
				P_Earthquake(player.mo, player.mo, 90 * player.mo.scale)
				searchBlockmap("objects", function(mo, found)
					if found and found.valid and found.health and 
							P_CheckSight(mo, found) and (found.z < mo.z + 
							mo.height / 2 and found.z > mo.z - mo.height / 2)
						P_DamageMobj(found, mo, mo, 1, 0)
					end
				end, mo, px-br, px+br, py-br, py+br)
				JumpManager(player.mo, 3 * FRACUNIT + 1 * FRACUNIT / 2)
				player.mo.state = S_PLAY_JUMP
				player.mo.momx = $ / 2
				player.mo.momy = $ / 2
				player.em_grounpwnd = false
				player.em_pounding = false
			end
		end
	end
end

//these handle dust spawning for all the different jumps, since it's used a lot
local function DustSpawners(orimo, dist, airmo, watermo)
	if orimo.eflags & MFE_UNDERWATER or orimo.eflags & MFE_GOOWATER
		P_SpawnMobjFromMobj(orimo, dist, 0, 0, watermo)
		P_SpawnMobjFromMobj(orimo, dist * -1, 0, 0, watermo)
		P_SpawnMobjFromMobj(orimo, 0, dist, 0, watermo)
		P_SpawnMobjFromMobj(orimo, 0, dist * -1, 0, watermo)
	else
		P_SpawnMobjFromMobj(orimo, dist, 0, 0, airmo)
		P_SpawnMobjFromMobj(orimo, dist * -1, 0, 0, airmo)
		P_SpawnMobjFromMobj(orimo, 0, dist, 0, airmo)
		P_SpawnMobjFromMobj(orimo, 0, dist * -1, 0, airmo)
	end
end
local function SpawnDust(player)
	DustSpawners(player.mo, 30 * FRACUNIT, MT_ARIDDUST, MT_MEDIUMBUBBLE)
end
local function SpawnMoreDust(player)
	SpawnDust(player)
	DustSpawners(player.mo, 60 * FRACUNIT, MT_DUST, MT_SMALLBUBBLE)
end
local function SpawnTornadoDust(player)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_EXTRALARGEBUBBLE).em_custAI = 
				true
	else
		P_SpawnThokMobj(player)
	end
end
//this ensures any bubbles spawned in SpawnTornadoDust gets eventually removed
local function TornadoBubbles(mo)
	if mo.em_custAI == nil or not mo.em_custAI
		return
	end
	
	if mo.em_bubtimer == nil
		mo.em_bubtimer = 2 * TICRATE
	end
	if mo.em_bubtimer <= 0
		P_RemoveMobj(mo)
	else
		mo.em_bubtimer = $ - 1
	end
	return
end

local function LongJumpTornado(player)
	if player.em_windjumps == nil
		player.em_windjumps = 0
	end
	if player.mo.state == S_PLAY_PAIN or player.playerstate == PST_DEAD or 
			player.powers[pw_carry] != CR_NONE
		return
	end
	if player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(player.mo)
		player.em_windjumps = 0
	end
	//This makes the player spin in the air while high-jumping
	if player.pflags & PF_THOKKED and not player.em_pounding
		if (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz <= 0
			Speening(player)
			if player.mo.momz < -10 * player.mo.scale
				SpawnTornadoDust(player)
			end
		elseif not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz >= 0
			Speening(player)
			if player.mo.momz > 10 * player.mo.scale
				SpawnTornadoDust(player)
			end
		else
			StateSetter(player.mo, S_PLAY_FALL)
		end
	end
	if player.em_divetornado == nil
		player.em_divetornado = false
	end
	if (player.cmd.buttons & BT_CUSTOM1) and not (player.em_pounding or 
			player.em_sliding)
		//this makes the player dive if they press custom 1 on the ground
		if P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
			if not player.em_divetornado
				S_StartSound(player.mo, sfx_s3k4b)
				JumpManager(player.mo, 7 * FRACUNIT)
				P_InstaThrust(player.mo, player.mo.angle, ThrustSpeeds(player))
				player.mo.state = S_PLAY_ROLL
				player.powers[pw_strong] = STR_WALL|STR_ANIM
				player.pflags = $ | PF_SPINNING
				player.em_divetornado = true
			end
		/*this makes the player do a deadly tornado glide if they hold custom 1
		while in the air*/
		elseif player.mo.state != S_PLAY_ROLL
			P_SpawnSkidDust(player, 25 * player.mo.scale)
			if not S_SoundPlaying(player.mo, sfx_prloop)
				S_StartSound(player.mo, sfx_prloop)
			end
			Speening(player)
			StateSetter(player.mo, S_PLAY_CLING)
			player.pflags = $ & ~PF_THOKKED
			player.powers[pw_strong] = STR_ATTACK|STR_SPIKE|STR_WALL|STR_ANIM
			if (player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz >= 2 * 
					player.mo.scale) or (not (player.mo.eflags & 
					MFE_VERTICALFLIP) and player.mo.momz <= -2 * player.mo.scale)
				JumpManager(player.mo, -2 * FRACUNIT)
			end
			player.em_divetornado = true
		end
	elseif not (player.cmd.buttons & BT_CUSTOM1)
		if P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
			player.em_divetornado = false
		end
		if player.mo.state == S_PLAY_CLING
			player.mo.state = S_PLAY_FALL
		end
	end
	/*this spawns a ghost trail if the player has dived and allows the player to
	jump out of dive*/
	if player.em_divetornado and player.mo.state == S_PLAY_ROLL
		P_SpawnGhostMobj(player.mo)
		if player.cmd.buttons & BT_JUMP
			P_DoJump(player, true)
			player.em_divetornado = false
		end
	end
end

/*this nerfs her wind abilities while underwater or in space so long as she
doesn't have any air-based shields*/
local function WaterShieldCheck(player, hight)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(player.mo)
		if not (player.powers[pw_shield] == SH_WHIRLWIND or 
				player.powers[pw_shield] & SH_PROTECTWATER)
			return hight - hight / 3
		end
	end
	return hight
end

local function HighNThirdJump(player)
	if not EmSkinCheck(player)
		return
	end
	
	/*this makes it so the player can't high jump if they're long jumping or
	doing the tornado*/
	if (player.em_divetornado and player.mo.state == S_PLAY_ROLL) or 
			player.mo.state == S_PLAY_CLING
		return true
	end
	//this makes the player perform the high jump
	if player.em_windjumps <= 0
		StateSetter(player.mo, S_PLAY_SPINDASH)
		SpawnMoreDust(player)
		S_StartSound(player.mo, sfx_wdjump)
		player.pflags = $ | PF_THOKKED & ~PF_STARTJUMP
		JumpManager(player.mo, WaterShieldCheck(player, 18 * FRACUNIT))
		player.em_windjumps = 1
	/*this makes the player perform an extra little hop that thrusts the
	player forward after high-jumping*/
	elseif player.em_windjumps == 1
		StateSetter(player.mo, S_PLAY_FLOAT)
		SpawnDust(player)
		S_StartSound(player.mo, sfx_wirlsg)
		P_InstaThrust(player.mo, player.mo.angle, ThrustSpeeds(player))
		player.pflags = $ | PF_THOKKED & ~PF_STARTJUMP
		JumpManager(player.mo, WaterShieldCheck(player, 7 * FRACUNIT))
		player.em_windjumps = 2
	end
	return true
end

local function Footsteps(mo, fram1, step1, fram2, step2)
	if mo.em_framnow == nil
		mo.em_framnow = -1
	end
	if mo.em_framnow != (mo.frame & FF_FRAMEMASK)
		if (mo.frame & FF_FRAMEMASK) == fram1
			S_StartSound(mo, step1)
		elseif (mo.frame & FF_FRAMEMASK) == fram2 and fram2 != nil
			if step2 == nil
				step2 = step1
			end
			S_StartSound(mo, step2)
		end
		mo.em_framnow = mo.frame & FF_FRAMEMASK
	end
end

local function MiscStuff(player)
	//this allows the player to breathe underwater and in space due to nerfs
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		player.powers[pw_underwater] = $ + 1
	elseif P_InSpaceSector(player.mo)
		player.powers[pw_spacetime] = $ + 1
	end
	//this controls the sound effects for walking and running and crawling
	if P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
		if player.mo.state == S_PLAY_WALK
			Footsteps(player.mo, 1, sfx_hfclp1, 4, sfx_hfclp2)
		elseif player.mo.state == S_PLAY_RUN
			Footsteps(player.mo, 1, sfx_gllop1, 2, sfx_gllop2)
		elseif player.mo.state == S_PLAY_CLIMB
			Footsteps(player.mo, 0, sfx_msquid, 2)
		end
	end
	//this is the secret bit, shhh
	if player.em_horseishere == nil
		player.em_horseishere = false
	end
	if (player.cmd.buttons & BT_CUSTOM3) and (player.cmd.buttons & BT_TOSSFLAG)
			and P_IsObjectOnGround(player.mo) and player.mo.momx == 0 and
			player.mo.momy == 0
		if not player.em_horseishere
			S_StartSound(player.mo, sfx_rglhrs)
			player.em_horseishere = true
		end
	elseif not P_IsObjectOnGround(player.mo) or player.mo.momx != 0 or
			player.mo.momy != 0 and player.em_horseishere
		player.em_horseishere = false
	end
	if player.em_horseishere
		StateSetter(player.mo, S_PLAY_FLY_TIRED)
	end
end

//this makes it so the player can't grab air bubbles, since they don't need it
local function NoBubbles(special, toucher)
	if toucher.skin == "emmette"
		return true
	end
end

--Hooks
addHook("SpinSpecial", CrawlNPTrigger)
addHook("AbilitySpecial", HighNThirdJump)

addHook("PlayerThink", function(player)
	if not EmSkinCheck(player)
		return
	end
	
	SlideGPound(player)
	LongJumpTornado(player)
	MiscStuff(player)
end)

addHook("MobjThinker", TornadoBubbles, MT_EXTRALARGEBUBBLE)
addHook("TouchSpecial", NoBubbles, MT_EXTRALARGEBUBBLE)